
$regfile = "m8def.dat"                                      ' specify the used micro
$crystal = 8000000
$hwstack = 32
$swstack = 10
$framesize = 40


'=== Configuration ===
Poweraan Alias Portd.2
Led Alias Portb.1
Drukknop Alias Pind.3

Config Poweraan = Output
Config Led = Output
Config Drukknop = Input

Set Portd.3                                                 'Pull-up weerstand aan voor de button


Dim Wacht As Word


Waitms 100                                                  'Even wachten totdat alles een beetje stabiel is
Set Poweraan                                                'Schakel de voeding in
Bitwait Drukknop , Set                                      'Wacht tot de knop weer is los gelaten



'=== Main ===
Do
'* Hier je hoofdprogramma
If Drukknop = 0 Then Gosub Knopingedrukt                    ' Drukknop wordt ingedrukt ga naar de sub om te kijken hoelang de knop wordt ingedrukt. Wil je direct een Shutdown doe dan GOSUB SHUTDOWN.
Loop
End


'=== Subroutines ===

Knopingedrukt:
Wacht = 0                                                   'Zet teller op nul
While Drukknop = 0                                          'Blijf in een lus totdat de knop weer is losgelaten
   Incr Wacht                                               'Verhoog de wacht teller
   Waitms 1
   If Wacht > 65000 Then Wacht = 65000                      'Knop wel erg lang ingedrukt
Wend
If Wacht > 15 And Wacht < 2000 Then                         ' Wacht>15 om kontaktdender te voorkomen, knop (ongeveer) korter dan 2000ms=2s ingedrukt
  '* Doe hier je sub als de knop kort wordt ingedrukt
End If
If Wacht => 2000 Then                                       'Knop lager dan 2sec ingedrukt
   Gosub Shutdown
End If

Return


Shutdown:
Bitwait Drukknop , Set                                      'Wacht tot de knop weer is los gelaten
Reset Poweraan                                              'Schakel de voeding weer uit
Return